import { Mesh } from 'itk-wasm';
import MeshToPolyDataOptions from './mesh-to-poly-data-options.js';
import MeshToPolyDataResult from './mesh-to-poly-data-result.js';
/**
 * Convert an itk::Mesh to an itk::PolyData
 *
 * @param {Mesh} mesh - Input mesh
 * @param {MeshToPolyDataOptions} options - options object
 *
 * @returns {Promise<MeshToPolyDataResult>} - result object
 */
declare function meshToPolyData(mesh: Mesh, options?: MeshToPolyDataOptions): Promise<MeshToPolyDataResult>;
export default meshToPolyData;
