// Generated file. To retain edits, remove this comment.
import { InterfaceTypes, runPipelineNode } from 'itk-wasm';
import path from 'path';
import { fileURLToPath } from 'url';
/**
 * Convert an itk::PolyData to an itk::Mesh
 *
 * @param {PolyData} polyData - Input polydata
 *
 * @returns {Promise<PolyDataToMeshNodeResult>} - result object
 */
async function polyDataToMeshNode(polyData) {
    const desiredOutputs = [
        { type: InterfaceTypes.Mesh },
    ];
    const inputs = [
        { type: InterfaceTypes.PolyData, data: polyData },
    ];
    const args = [];
    // Inputs
    const polyDataName = '0';
    args.push(polyDataName);
    // Outputs
    const meshName = '0';
    args.push(meshName);
    // Options
    args.push('--memory-io');
    const pipelinePath = path.join(path.dirname(fileURLToPath(import.meta.url)), 'pipelines', 'poly-data-to-mesh');
    const { returnValue, stderr, outputs } = await runPipelineNode(pipelinePath, args, desiredOutputs, inputs);
    if (returnValue !== 0 && stderr !== "") {
        throw new Error(stderr);
    }
    const result = {
        mesh: outputs[0]?.data,
    };
    return result;
}
export default polyDataToMeshNode;
//# sourceMappingURL=poly-data-to-mesh-node.js.map