import { PolyData } from 'itk-wasm';
import PolyDataToMeshOptions from './poly-data-to-mesh-options.js';
import PolyDataToMeshResult from './poly-data-to-mesh-result.js';
/**
 * Convert an itk::PolyData to an itk::Mesh
 *
 * @param {PolyData} polyData - Input polydata
 * @param {PolyDataToMeshOptions} options - options object
 *
 * @returns {Promise<PolyDataToMeshResult>} - result object
 */
declare function polyDataToMesh(polyData: PolyData, options?: PolyDataToMeshOptions): Promise<PolyDataToMeshResult>;
export default polyDataToMesh;
